-- ===============================================
-- Author	  : FID.Intan	  
-- Create date: 15-Desember-2014
-- Description:	Insert Data to TB_T_DLV_FI_TRANS_D for Billing Status = 3
-- Bug ID	  : 493
-- ===============================================

CREATE PROCEDURE [dbo].[SP_PROTO_INSERT_TEMP_TRANS_D_INV_3]
	@PROCESS_ID BIGINT,
	@INV_NO VARCHAR(20),
	@DOC_NO VARCHAR(15),
	@BILLING_STS VARCHAR(1)
AS

DECLARE
	@DOC_YEAR VARCHAR(4),
	@TRANSACTION_CD VARCHAR(3),
	@CONDITION_TYPE VARCHAR(5),
	@GL_ACCOUNT VARCHAR(10),
	@EXCHANGE_RATE DECIMAL,
	@LOCAL_CURR_CD VARCHAR(3),
	@DC_INDICATOR VARCHAR(1),
	@LOCAL_CURR VARCHAR(3),
	@DOC_TYPE VARCHAR(2),
	@PO_NO VARCHAR(11),
	@DOC_AMT NUMERIC(18, 0),
	@TAX_CD VARCHAR(2),
	@USERID VARCHAR(20),
	@CREATED_DT VARCHAR(20)
BEGIN
	--Get DOC Year
	SET @DOC_YEAR = CONVERT(VARCHAR, YEAR(GETDATE()))

	--Get Transaction Code
	SELECT @TRANSACTION_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_TRANS_TYPE_LIV_CANCEL'

	--Get Exchange Rate
	SELECT @EXCHANGE_RATE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_EXCHANGE_RATE'

	--Get Local Curr Cd
	SELECT @LOCAL_CURR_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_LOCAL_CURR_CD'

	--Get Local Curr
	SELECT @LOCAL_CURR = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_LOCAL_CURR'
	
	--Get DOC Type
	SELECT @DOC_TYPE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_DOC_TYPE_LIV'
	
	--Get PO No
	SELECT @PO_NO = MAX(CONVERT(VARCHAR(11), PO_NO)) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO 

	--Get UserID
	SELECT TOP 1 @USERID = CONVERT(VARCHAR(20), UPDATE_BY) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND PO_NO = @PO_NO AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS
	SELECT TOP 1 @CREATED_DT = MAX(UPDATE_DT) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND PO_NO = @PO_NO AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS

	/*** Debit ***/
	--Get Condition Type
	SELECT @CONDITION_TYPE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_CONDITION_TYPE_CREDIT'

	--Get GL Account
	SELECT @GL_ACCOUNT = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_GL_ACC_PO_LIV_POST_CREDT'

	--Get Debit Credit Indicator
	SELECT @DC_INDICATOR = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_INDICATOR_CREDIT'

	--Get DOC Amount
	SELECT @DOC_AMT = SUM(CONVERT(NUMERIC(15, 3), PO_AMT)) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO

	--Get Tax CD
	SELECT @TAX_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_TAX_CD_LIV'

	--REMARK UPDATE_DT in GROUP BY and Change to MAX(UPDATE_DT) in SELECT
	INSERT INTO TB_T_DLV_FI_TRANS_D 
	SELECT DISTINCT @DOC_NO AS DOC_NO,
		   @DOC_YEAR AS DOC_YEAR,
		   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_TRANS_D WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY INV_NO) AS DOC_ITEM,
		   @CONDITION_TYPE AS CONDITION_TYPE,
		   SUBSTRING(SUPPLIER_NO, 1, 4) AS GL_ACCOUNT,
		   NULL AS ROUTE_CD,
		   NULL AS DOC_QTY,
		   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D1', BILLING_STS)) * (-1) AS DOC_AMT,
		   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR_CD,
		   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D1', BILLING_STS)) * @EXCHANGE_RATE * (-1) AS LOCAL_AMT,
		   @LOCAL_CURR_CD AS LOCAL_CURR_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS PO_NO,
		   NULL AS TAX_CD,
		   @EXCHANGE_RATE AS EXCHANGE_RATE,
		   NULL AS COST_CENTER_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS ITEM_TEXT,
		   @TRANSACTION_CD AS TRANSACTION_NO,
		   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO, --get wbsno but duplicate
		   NULL AS UOM,
		   @USERID AS CREATED_BY,
		   @CREATED_DT AS CREATED_DT,
		   NULL AS CHANGED_BY,
		   NULL AS CHANGED_DT
	FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
	--GROUP BY SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, BILLING_STS ORDER BY PO_NO
	GROUP BY SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO, BILLING_STS ORDER BY PO_NO
	
	EXEC SP_PROTO_INSERT_DVL_FI_JOURNAL_INV @PROCESS_ID, @DOC_NO, @DOC_YEAR, @INV_NO, '2', @TRANSACTION_CD, @CONDITION_TYPE, @DC_INDICATOR,
		@GL_ACCOUNT, @EXCHANGE_RATE, @LOCAL_CURR, @PO_NO, @DOC_TYPE, '3'

	/*** Debit 2 ***/
	--Get GL Account
	SELECT @GL_ACCOUNT = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_GL_ACC_TAX_LIV_POST_CRDT'

	--Get DOC Amount
	SELECT @DOC_AMT = MAX(CONVERT(NUMERIC(18, 0), TAX_AMT)) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO

	--REMARK UPDATE DT in GROUP BY and Change to MAX(UPDATE_DT) in SELECT
	INSERT INTO TB_T_DLV_FI_TRANS_D 
	SELECT DISTINCT @DOC_NO AS DOC_NO,
		   @DOC_YEAR AS DOC_YEAR,
		   '' AS DOC_ITEM,
		   @CONDITION_TYPE AS CONDITION_TYPE,
		   @GL_ACCOUNT AS GL_ACCOUNT,
		   NULL AS ROUTE_CD,
		   NULL AS DOC_QTY,
		   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, DELIVERY_NOTE_NO, 'D20', BILLING_STS)) * (-1) AS DOC_AMT,
		   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR_CD,
		   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, DELIVERY_NOTE_NO, 'D20', BILLING_STS)) * @EXCHANGE_RATE * (-1) AS LOCAL_AMT,
		   @LOCAL_CURR_CD AS LOCAL_CURR_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV', '', '', @PROCESS_ID) AS PO_NO,
		   NULL AS TAX_CD,
		   @EXCHANGE_RATE AS EXCHANGE_RATE,
		   NULL AS COST_CENTER_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV', '', '', @PROCESS_ID) AS ITEM_TEXT,
		   @TRANSACTION_CD AS TRANSACTION_NO,
		   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
		   NULL AS UOM,
		   @USERID AS CREATED_BY,
		   @CREATED_DT AS CREATED_DT,
		   NULL AS CHANGED_BY,
		   NULL AS CHANGED_DT
	FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
	--GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, DELIVERY_NOTE_NO/*PO_NO*/ ORDER BY PO_NO
	GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO, DELIVERY_NOTE_NO /*PO_NO*/ ORDER BY PO_NO

	EXEC SP_PROTO_INSERT_DVL_FI_JOURNAL_INV @PROCESS_ID, @DOC_NO, @DOC_YEAR, @INV_NO, '3', @TRANSACTION_CD, @CONDITION_TYPE, @DC_INDICATOR,
		@GL_ACCOUNT, @EXCHANGE_RATE, @LOCAL_CURR, @PO_NO, @DOC_TYPE, '3'

	UPDATE x
	SET x.DOC_ITEM_NO = x.RN
	FROM (
		  SELECT DOC_ITEM_NO, ROW_NUMBER() OVER (ORDER BY DOC_NO) AS RN
		  FROM TB_T_DLV_FI_TRANS_D where doc_no = @DOC_NO
      ) x

	/*** Debit ***/ 
	--Get Condition Type
	SELECT @CONDITION_TYPE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_CONDITION_TYPE_DEBIT'

	--Get GL Account
	SELECT @GL_ACCOUNT = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_GL_ACC_PO_LIV_POST_DEBIT'

	--Get Debit Credit Indicator
	SELECT @DC_INDICATOR = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_INDICATOR_DEBIT'

	--REMARK UPDATE DT in GROUP BY and Change to MAX(UPDATE_DT) in SELECT
	INSERT INTO TB_T_DLV_FI_TRANS_D 
	SELECT DISTINCT @DOC_NO AS DOC_NO,
		   @DOC_YEAR AS DOC_YEAR,
		   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_TRANS_D WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY INV_NO) AS DOC_ITEM,
		   @CONDITION_TYPE AS CONDITION_TYPE,
		   @GL_ACCOUNT AS GL_ACCOUNT,
		   NULL AS ROUTE_CD,
		   NULL AS DOC_QTY,
		   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D3', @BILLING_STS)) AS DOC_AMT,
		   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR_CD,
		   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D3', @BILLING_STS)) * @EXCHANGE_RATE AS LOCAL_AMT,
		   @LOCAL_CURR_CD AS LOCAL_CURR_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS PO_NO,
		   NULL AS TAX_CD,
		   @EXCHANGE_RATE AS EXCHANGE_RATE,
		   NULL AS COST_CENTER_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS ITEM_TEXT,
		   @TRANSACTION_CD AS TRANSACTION_NO,
		   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
		   NULL AS UOM,
		   @USERID AS CREATED_BY,
		   @CREATED_DT AS CREATED_DT,
		   NULL AS CHANGED_BY,
		   NULL AS CHANGED_DT
	FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
	--GROUP BY SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, BILLING_STS ORDER BY PO_NO
	GROUP BY SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO, BILLING_STS ORDER BY PO_NO

	EXEC SP_PROTO_INSERT_DVL_FI_JOURNAL_INV @PROCESS_ID, @DOC_NO, @DOC_YEAR, @INV_NO, '1', @TRANSACTION_CD, @CONDITION_TYPE, @DC_INDICATOR,
		@GL_ACCOUNT, @EXCHANGE_RATE, @LOCAL_CURR, @PO_NO, @DOC_TYPE, '3'
	
END

